#include<bits/stdc++.h>
using namespace std;

#define out(x) #x << " = " << x << " "
#ifndef LOCAL
#define endl "\n"
#define cerr  if(false) cerr
#endif

const int MAX_N = 1e6 + 10;
const int MAX_K = 1e6 + 10;
const int INF = 1e9 + 10;


int n, m, k;
int table[MAX_N];
bool occ[MAX_N];
pair <int, int> cells[MAX_K];

int g (int x, int y) {
    return y * m + x;
}

bool isIn (int x, int y) {
    return x >= 0 && y >= 0 && x < n && y < m;
}

pair<int, int> pos[5][5];

void preset () {
    //  -
    // ---
    pos[0][0] = {-1, 0};
    pos[0][1] = {0, 0};
    pos[0][2] = {1, 0};
    pos[0][3] = {0, -1};

    //  -
    // --
    //  -
    pos[1][0] = {-1, 0};
    pos[1][1] = {0, 0};
    pos[1][2] = {0, -1};
    pos[1][3] = {0, 1};

    // -
    // --
    // -
    pos[2][0] = {1, 0};
    pos[2][1] = {0, 0};
    pos[2][2] = {0, -1};
    pos[2][3] = {0, 1};

    // ---
    //  -
    pos[3][0] = {-1, 0};
    pos[3][1] = {0, 0};
    pos[3][2] = {1, 0};
    pos[3][3] = {0, 1};

}

bool checkForOcc (int x, int y, int ind) {
    for (int i = 0; i < 4; i ++) {
        int cX = x + pos[ind][i].second;
        int cY = y + pos[ind][i].first;
        if (!isIn(cX, cY) || occ[g(cX, cY)]) return false;
    }

    return true;
}

int getSum (int x, int y, int ind) {
    int sum = 0;
    for (int i = 0; i < 4; i ++) {
        int cX = x + pos[ind][i].second;
        int cY = y + pos[ind][i].first;
        sum += table[g(cX, cY)];
    }

    return sum;
}

void setOcc (int x, int y, int ind, bool val) {
    for (int i = 0; i < 4; i ++) {
        int cX = x + pos[ind][i].second;
        int cY = y + pos[ind][i].first;
        occ[g(cX, cY)] = val;
    }
}

void print(int depth) {
    for (int i = 0; i < depth; i ++) {
        cerr << "  ";
    }
}

int solve (int i) {
    print(i); cerr << "In for " << out(i) << endl; 
    
    if (i == k) {
        print(i); cerr << "Returning 0 (base case)" << endl;
        return 0;
    }


    int currX = cells[i].first;
    int currY = cells[i].second;

    int ans = -INF;
    for (int rot = 0; rot < 4; rot ++) {
        print(i); cerr << "Checking " << out(rot) << endl;
        if (!checkForOcc(currX, currY, rot)) continue;
        print(i); cerr << out(rot) << " is valid" << endl;

        setOcc(currX, currY, rot, true);
        int temp = solve(i + 1) + getSum(currX, currY, rot);
        print(i); cerr << out(temp) << endl;
        ans = max(ans, temp);
        print(i); cerr << "New " << out(ans) << endl;
        setOcc(currX, currY, rot, false);
    }

    return ans;
}




int main(){
    #ifndef LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    #endif
    
    
    cin >> n >> m;
    for (int i = 0; i < n; i ++) {
        for (int j = 0; j < m; j ++) {
            cin >> table[g(i, j)];
        }
    }

    preset();
    for (int i = 0; i < n; i ++) {
        for (int j = 0; j < m; j ++) {
            cerr << table[g(i, j)] << " ";
        }
        cerr << endl;
    }

    cin >> k;
    cerr << out(k) << endl;

    int ans = 0;
    for (int i = 0; i < k; i ++) {
        int a, b;
        cin >> b >> a;
        int temp = 0;
        for (int rot = 0; rot < 4; rot ++) {
            if (checkForOcc(a, b, rot)) {
                temp = max(temp, getSum(a, b, rot));
            }
        } 
        if (temp == 0) ans = -INF;
        ans += temp;
        // cells[i] = {a, b}; 
    }


    // int ans = solve(0);
    if (ans < 0) {
        cout << "No" << endl;
    } else {
        cout << ans << endl;
    }
    return 0;
}

