#include<bits/stdc++.h>
using namespace std;

#define out(x) #x << " = " << x << " "
#ifndef LOCAL
#define endl "\n"
#define cerr  if(false) cerr
#endif

const int MAX_N = 1e6 + 10;
const int MAX_K = 1e6 + 10;
const int INF = 1e9 + 10;


int n, m, k;
int table[MAX_N];
bool occ[MAX_N];
bool special[MAX_N];
pair <int, int> cells[MAX_K];
int rotation_[MAX_K];

int g (int x, int y) {
    return x * m + y;
}

bool isIn (int x, int y) {
    return x >= 0 && y >= 0 && x < n && y < m;
}

bool isBad (int ind) {
    int currX = cells[ind].first;
    int currY = cells[ind].second;

    for (int i = 1; i <= 2; i ++) {
        if (isIn(currX - i, currY) && special[g(currX - i, currY)]) return false;
        if (isIn(currX + i, currY) && special[g(currX + i, currY)]) return false;
        if (isIn(currX, currY - i) && special[g(currX, currY - i)]) return false;
        if (isIn(currX, currY + i) && special[g(currX, currY + i)]) return false;
    }

    for (int i = -1; i <= 1; i += 2) {
        for (int j = -1; j <= 1; j += 2) {
            if (isIn(currX + i, currY + j) && special[g(currX + i, currY + j)]) return false;
        }
    }

    return true;
}

pair<int, int> pos[5][5];

void preset () {
    //  -
    // ---
    pos[0][0] = {-1, 0};
    pos[0][1] = {0, 0};
    pos[0][2] = {1, 0};
    pos[0][3] = {0, -1};

    //  -
    // --
    //  -
    pos[1][0] = {-1, 0};
    pos[1][1] = {0, 0};
    pos[1][2] = {0, -1};
    pos[1][3] = {0, 1};

    // -
    // --
    // -
    pos[2][0] = {1, 0};
    pos[2][1] = {0, 0};
    pos[2][2] = {0, -1};
    pos[2][3] = {0, 1};

    // ---
    //  -
    pos[3][0] = {-1, 0};
    pos[3][1] = {0, 0};
    pos[3][2] = {1, 0};
    pos[3][3] = {0, 1};

}

bool checkForOcc (int x, int y, int ind) {
    for (int i = 0; i < 4; i ++) {
        int cX = x + pos[ind][i].second;
        int cY = y + pos[ind][i].first;
        if (!(cX == x && cY == y) && special[g(cX, cY)]) return false;
        if (!isIn(cX, cY) || occ[g(cX, cY)]) return false;
    }

    return true;
}

int getSum (int x, int y, int ind) {
    int sum = 0;
    for (int i = 0; i < 4; i ++) {
        int cX = x + pos[ind][i].second;
        int cY = y + pos[ind][i].first;
        sum += table[g(cX, cY)];
    }

    return sum;
}

void setOcc (int x, int y, int ind, bool val) {
    for (int i = 0; i < 4; i ++) {
        int cX = x + pos[ind][i].second;
        int cY = y + pos[ind][i].first;
        occ[g(cX, cY)] = val;
    }
}

void print(int depth) {
    for (int i = 0; i < depth; i ++) {
        cerr << "  ";
    }
    
}

int solve (int i) {    
    if (i == k) {
        return 0;
    }


    int currX = cells[i].first;
    int currY = cells[i].second;

    int ans = -INF;
    if (rotation_[i] != -1) {
        setOcc(currX, currY, rotation_[i], true);
        int temp = solve(i + 1) + getSum(currX, currY, rotation_[i]);
        ans = max(ans, temp);
        setOcc(currX, currY, rotation_[i], false);
    } else {
        for (int rot = 0; rot < 4; rot ++) {
            if (!checkForOcc(currX, currY, rot)) continue;
            setOcc(currX, currY, rot, true);
            int temp = solve(i + 1) + getSum(currX, currY, rot);
            ans = max(ans, temp);
            setOcc(currX, currY, rot, false);
        }
    }
    return ans;
}




int main(){
    #ifndef LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    #endif
    
    
    cin >> n >> m;
    for (int i = 0; i < n; i ++) {
        for (int j = 0; j < m; j ++) {
            cin >> table[g(i, j)];
        }
    }

    preset();

    cin >> k;

    for (int i = 0; i < k; i ++) {
        int a, b;
        cin >> a >> b;
        cells[i] = {a, b}; 
        special[g(a, b)] = true;
    }

    for (int i = 0; i < k; i ++) {
        int a = cells[i].first, b = cells[i].second;
        if (!isBad(i)) {
            rotation_[i] = -1;
            continue;
        }
        int temp = -1;
        int bestRot = -1;
        for (int rot = 0; rot < 4; rot ++) {
            if (checkForOcc(a, b, rot)) {
                int sum = getSum(a, b, rot);
                if (sum > temp) {
                    temp = sum;
                    bestRot = rot;
                }
            }
        } 

        if (temp == -1) {
            cout << "No" << endl;
            return 0;
        }

        rotation_[i] = bestRot;

    }

    int ans = solve(0);
    if (ans < 0) {
        cout << "No" << endl;
    } else {
        cout << ans << endl;
    }
    return 0;
}

