# include <iostream>
# include <vector>
# include <algorithm>
# include <cassert>
using namespace std;

const int INF=2e9;
const int MAX=1e6+11;
vector<vector<int>> a;
vector<vector<int>> tab;
pair<int, int> spec[MAX];
int n,m,k;

void read()
{
    cin>>n>>m;
    a.resize(n+1);
    tab.resize(n+1);
    for(int i=1;i<=n;i++)
    {
        a[i].resize(m+1);
        tab[i].resize(m+1);
        for(int j=1;j<=m;j++) cin>>a[i][j];
    }

    cin>>k;
    for(int i=1;i<=k;i++)
    {
        cin>>spec[i].first>>spec[i].second;
        spec[i].first++;
        spec[i].second++;
    }

    sort(spec+1,spec+1+k);
    for(int i=1;i<=k;i++)
    {
        tab[spec[i].first][spec[i].second]=i;
    }
}

///---------------------------------------------

int adj[8][2]={{0,1},{0,-1},{1,0},{1,1},{1,-1},{-1,0},{-1,1},{-1,-1}};
bool vis[MAX];

bool in(int x, int y)
{
    return (1<=x and x<=n and 1<=y and y<=m);
}

int CNT=0;

void dfs(int curr)
{
    vis[curr]=1;
    CNT++;

    for(int i=0;i<8;i++)
    {
        int x=spec[curr].first+adj[i][0];
        int y=spec[curr].second+adj[i][1];

        if(in(x,y) and tab[x][y]!=0 and vis[tab[x][y]]==0) dfs(tab[x][y]);
    }
}

int br[MAX];

bool check()
{
    if(n<=2 or m<=2) return false;

    for(int i=1;i<=k;i++)
    {
        if(spec[i].first==1 and spec[i].second==1) return false;
        if(spec[i].first==1 and spec[i].second==m) return false;
        if(spec[i].first==n and spec[i].second==1) return false;
        if(spec[i].first==n and spec[i].second==m) return false;
    }

    for(int i=1;i<=k;i++)
    {
        if(!vis[i])
        {
            CNT=0;
            dfs(i);
            br[i]=CNT;
            if(CNT>=3) return false;
        }
    }

    return true;
}

///---------------------------------------------

int get_val(int x, int y, int tp)
{
    if(tp==1)
    {
        if(y==1 or y==m or x==1) return -INF;
        return a[x][y-1]+a[x][y]+a[x][y+1]+a[x-1][y];
    }

    if(tp==2)
    {
        if(y==1 or y==m or x==n) return -INF;
        return a[x][y-1]+a[x][y]+a[x][y+1]+a[x+1][y];
    }

    if(tp==3)
    {
        if(x==1 or x==n or y==1) return -INF;
        return a[x-1][y]+a[x][y]+a[x+1][y]+a[x][y-1];
    }

    if(tp==4)
    {
        if(x==1 or x==n or y==m) return -INF;
        return a[x-1][y]+a[x][y]+a[x+1][y]+a[x][y+1];
    }

    return INF;
}

bool used[MAX];
int adj2[4][2]={{1,0},{0,1},{-1,0},{0,-1}};

bool nxt_to(int x, int y, int x2, int y2)
{
    return (abs(x-x2)+abs(y-y2)==1);
}

void solve()
{
    if(!check()) {cout<<"No"<<"\n";return ;}

    int ans=0;
    for(int i=1;i<=k;i++)
    {
        if(used[i]==1) continue;
        int curr=-INF;

        if(br[i]==1)
        {
             for(int tp=1;tp<=4;tp++) curr=max(curr,get_val(spec[i].first,spec[i].second,tp));
             ans+=curr;
             used[i]=1;
             continue;
        }

        int j=i;
        for(int d=0;d<8;d++)
        {
            int x=spec[i].first+adj[d][0];
            int y=spec[i].second+adj[d][1];
            if(in(x,y) and tab[x][y]!=0) j=tab[x][y];
        }

        //cout<<"->"<<i<<" "<<j<<endl;

        if(nxt_to(spec[i].first,spec[i].second,spec[j].first,spec[j].second))
        {
            if(spec[i].first==spec[j].first) curr=get_val(spec[i].first,spec[i].second,3)+get_val(spec[j].first,spec[j].second,4);
            else curr=get_val(spec[i].first,spec[i].second,1)+get_val(spec[j].first,spec[j].second,2);
        }
        else curr=get_val(spec[i].first,spec[i].second,1)+get_val(spec[j].first,spec[j].second,2);

        ans+=curr;
        used[i]=1;
        used[j]=1;
    }

    if(ans<0) cout<<"No"<<"\n";
    else cout<<ans<<"\n";
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);cout.tie(0);

    read();
    solve();

    return 0;
}
/*
4 4
1 2 3 4
5 6 7 8
9 10 11 12
13 14 15 16
2
2 2
2 1
*/
