# include <iostream>
# include <vector>
# include <algorithm>
# include <cassert>
using namespace std;

///posle vsicko na long long

const long long INF=2e9;
const long long MAX=1e6+11;
vector<vector<long long>> a;
vector<vector<long long>> tab;
vector<vector<bool>> used;
pair<long long, long long> spec[MAX];
long long n,m,k;

void read()
{
    cin>>n>>m;
    a.resize(n+1);
    tab.resize(n+1);
    used.resize(n+1);
    for(long long i=1;i<=n;i++)
    {
        a[i].resize(m+1);
        tab[i].resize(m+1);
        used[i].resize(m+1);
        for(long long j=1;j<=m;j++) cin>>a[i][j];
    }

    cin>>k;
    for(long long i=1;i<=k;i++)
    {
        cin>>spec[i].first>>spec[i].second;
        spec[i].first++;
        spec[i].second++;
    }

    sort(spec+1,spec+1+k);
    for(long long i=1;i<=k;i++)
    {
        tab[spec[i].first][spec[i].second]=i;
    }
}

bool in(long long x, long long y)
{
    return (1<=x and x<=n and 1<=y and y<=m);
}

bool can_move(long long id, long long tp)
{
    long long x=spec[id].first,y=spec[id].second;

    if(tp==1)
    {
        if(y==1 or y==m or x==1) return 0;
        if(used[x][y-1] or used[x][y] or used[x][y+1] or used[x-1][y]) return 0;
    }

    if(tp==2)
    {
        if(y==1 or y==m or x==n) return 0;
        if(used[x][y-1] or used[x][y] or used[x][y+1] or used[x+1][y]) return 0;
    }

    if(tp==3)
    {
        if(x==1 or x==n or y==1) return 0;
        if(used[x-1][y] or used[x][y] or used[x+1][y] or used[x][y-1]) return 0;
    }

    if(tp==4)
    {
        if(x==1 or x==n or y==m) return 0;
        if(used[x-1][y] or used[x][y] or used[x+1][y] or used[x][y+1]) return 0;
    }

    return true;
}

long long get_val(long long id, long long tp)
{
    long long x=spec[id].first,y=spec[id].second;

    if(tp==1)
    {
        if(y==1 or y==m or x==1) return -INF;
        if(used[x][y-1] or used[x][y] or used[x][y+1] or used[x-1][y]) return -INF;
        used[x][y-1]=used[x][y]=used[x][y+1]=used[x-1][y]=1;
        return a[x][y-1]+a[x][y]+a[x][y+1]+a[x-1][y];
    }

    if(tp==2)
    {
        if(y==1 or y==m or x==n) return -INF;
        if(used[x][y-1] or used[x][y] or used[x][y+1] or used[x+1][y]) return -INF;
        used[x][y-1]=used[x][y]=used[x][y+1]=used[x+1][y]=1;
        return a[x][y-1]+a[x][y]+a[x][y+1]+a[x+1][y];
    }

    if(tp==3)
    {
        if(x==1 or x==n or y==1) return -INF;
        if(used[x-1][y] or used[x][y] or used[x+1][y] or used[x][y-1]) return -INF;
        used[x-1][y]=used[x][y]=used[x+1][y]=used[x][y-1]=1;
        return a[x-1][y]+a[x][y]+a[x+1][y]+a[x][y-1];
    }

    if(tp==4)
    {
        if(x==1 or x==n or y==m) return -INF;
        if(used[x-1][y] or used[x][y] or used[x+1][y] or used[x][y+1]) return -INF;
        used[x-1][y]=used[x][y]=used[x+1][y]=used[x][y+1]=1;
        return a[x-1][y]+a[x][y]+a[x+1][y]+a[x][y+1];
    }

    return INF;
}

void remove_val(long long id, long long tp)
{
    long long x=spec[id].first,y=spec[id].second;

    if(tp==1)
    {
        if(y==1 or y==m or x==1) return ;
        used[x][y-1]=used[x][y]=used[x][y+1]=used[x-1][y]=0;
    }

    if(tp==2)
    {
        if(y==1 or y==m or x==n) return ;
        used[x][y-1]=used[x][y]=used[x][y+1]=used[x+1][y]=0;
    }

    if(tp==3)
    {
        if(x==1 or x==n or y==1) return ;
        used[x-1][y]=used[x][y]=used[x+1][y]=used[x][y-1]=0;
    }

    if(tp==4)
    {
        if(x==1 or x==n or y==m) return ;
        used[x-1][y]=used[x][y]=used[x+1][y]=used[x][y+1]=0;
    }
}

bool vis[MAX];
long long br_comp=0;
long long sz[MAX];
vector<long long> c[MAX];

void dfs(long long curr)
{
    //cout<<curr<<endl;

    vis[curr]=1;
    sz[br_comp]++;
    c[br_comp].push_back(curr);
    for(long long i=0;i<=2;i++)
    {
        for(long long j=0;j<=2;j++)
        {
            long long x2=spec[curr].first+i;
            long long y2=spec[curr].second+j;

            if(in(x2,y2) and tab[x2][y2]!=0 and vis[tab[x2][y2]]==0) dfs(tab[x2][y2]);
        }
    }
}

void make_comps()
{
    for(long long i=1;i<=k;i++)
    {
        if(!vis[i])
        {
            br_comp++;
            dfs(i);
        }
    }
}

long long curr_ans=-INF;

void rec(long long comp, long long i, long long ans)
{
    if(i==sz[comp])
    {
        curr_ans=max(curr_ans,ans);
        return ;
    }

    for(long long tp=1;tp<=4;tp++)
    {
        if(can_move(c[comp][i],tp))
        {
            long long cost=get_val(c[comp][i],tp);
            rec(comp,i+1,ans+cost);
            remove_val(c[comp][i],tp);
        }
    }
}

void solve()
{
   make_comps();
   //cout<<br_comp<<"\n";

   long long ans=0;
   for(long long comp=1;comp<=br_comp;comp++)
   {
        ///pochni ot 0
        curr_ans=-INF;
        rec(comp,0,0);
        if(curr_ans<0) {cout<<"No"<<"\n";return ;}
        ans+=curr_ans;
   }

   cout<<ans<<"\n";
}

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);cout.tie(0);

    read();
    solve();

    return 0;
}
/*
4 4
1 2 3 4
5 6 7 8
9 10 11 12
13 14 15 16
2
2 2
2 1
*/

