# include <iostream>
# include <vector>
# include <chrono>
using namespace std::chrono;
using namespace std;


std::chrono::time_point<std::chrono::system_clock> start,stop;

void time_passed()
{
    stop = high_resolution_clock::now();
    auto duration = duration_cast<milliseconds>(stop - start);
    //cout<<duration.count()<<"\n";
    if(duration.count()>270)
    {
        cout<<"No"<<"\n";
        exit(0);
    }
}

const int INF=2e9;
const int MAX=1e6+11;
vector<vector<int>> a;
vector<vector<int>> tab;
vector<vector<bool>> used;
pair<int, int> spec[MAX];
int n,m,k;

void read()
{
    cin>>n>>m;
    a.resize(n+1);
    tab.resize(n+1);
    used.resize(n+1);
    for(int i=1; i<=n; i++)
    {
        a[i].resize(m+1);
        tab[i].resize(m+1);
        used[i].resize(m+1);
        for(int j=1; j<=m; j++) cin>>a[i][j];
    }

    cin>>k;
    for(int i=1; i<=k; i++)
    {
        cin>>spec[i].first>>spec[i].second;
        spec[i].first++;
        spec[i].second++;
        tab[spec[i].first][spec[i].second]=i;
    }
}

bool in(int x, int y)
{
    return (1<=x and x<=n and 1<=y and y<=m);
}

bool can_move(int id, int tp)
{
    int x=spec[id].first,y=spec[id].second;

    switch(tp)
    {
    case 1:
    {
        if(y==1 or y==m or x==1) return 0;
        if(used[x][y-1] or used[x][y] or used[x][y+1] or used[x-1][y]) return 0;
        return true;
        break;
    }
    case 2:
    {
        if(y==1 or y==m or x==n) return 0;
        if(used[x][y-1] or used[x][y] or used[x][y+1] or used[x+1][y]) return 0;
        return true;
        break;
    }
    case 3:
    {
        if(x==1 or x==n or y==1) return 0;
        if(used[x-1][y] or used[x][y] or used[x+1][y] or used[x][y-1]) return 0;
        return true;
        break;
    }
    case 4:
    {
        if(x==1 or x==n or y==m) return 0;
        if(used[x-1][y] or used[x][y] or used[x+1][y] or used[x][y+1]) return 0;
        return true;
        break;
    }
    default:
    {
        return true;
        break;
    }
    }

    return true;
}

int get_val(int id, int tp)
{
    int x=spec[id].first,y=spec[id].second;

    switch(tp)
    {
    case 1:
    {
        if(y==1 or y==m or x==1) return -INF;
        if(used[x][y-1] or used[x][y] or used[x][y+1] or used[x-1][y]) return -INF;
        used[x][y-1]=used[x][y]=used[x][y+1]=used[x-1][y]=1;
        return a[x][y-1]+a[x][y]+a[x][y+1]+a[x-1][y];
        break;
    }
    case 2:
    {
        if(y==1 or y==m or x==n) return -INF;
        if(used[x][y-1] or used[x][y] or used[x][y+1] or used[x+1][y]) return -INF;
        used[x][y-1]=used[x][y]=used[x][y+1]=used[x+1][y]=1;
        return a[x][y-1]+a[x][y]+a[x][y+1]+a[x+1][y];
        break;
    }
    case 3:
    {
        if(x==1 or x==n or y==1) return -INF;
        if(used[x-1][y] or used[x][y] or used[x+1][y] or used[x][y-1]) return -INF;
        used[x-1][y]=used[x][y]=used[x+1][y]=used[x][y-1]=1;
        return a[x-1][y]+a[x][y]+a[x+1][y]+a[x][y-1];
        break;
    }
    case 4:
    {
        if(x==1 or x==n or y==m) return -INF;
        if(used[x-1][y] or used[x][y] or used[x+1][y] or used[x][y+1]) return -INF;
        used[x-1][y]=used[x][y]=used[x+1][y]=used[x][y+1]=1;
        return a[x-1][y]+a[x][y]+a[x+1][y]+a[x][y+1];
        break;
    }
    default:
    {
        return -INF;
    }
    }
}

void remove_val(int id, int tp)
{
    int x=spec[id].first,y=spec[id].second;

    switch(tp)
    {
    case 1:
    {
        if(y==1 or y==m or x==1) return ;
        used[x][y-1]=used[x][y]=used[x][y+1]=used[x-1][y]=0;
        break;
    }
    case 2:
    {
        if(y==1 or y==m or x==n) return ;
        used[x][y-1]=used[x][y]=used[x][y+1]=used[x+1][y]=0;
        break;
    }
    case 3:
    {
        if(x==1 or x==n or y==1) return ;
        used[x-1][y]=used[x][y]=used[x+1][y]=used[x][y-1]=0;
        break;
    }
    case 4:
    {
        if(x==1 or x==n or y==m) return ;
        used[x-1][y]=used[x][y]=used[x+1][y]=used[x][y+1]=0;
        break;
    }
    default:
    {
        return ;
        break;
    }
    }
}

bool vis[MAX];
int br_comp=0;
int sz[MAX];
vector<int> c[MAX];

void dfs(int curr)
{
    //cout<<curr<<endl;

    vis[curr]=1;
    sz[br_comp]++;
    c[br_comp].push_back(curr);
    for(int i=-2; i<=2; i++)
    {
        for(int j=-2; j<=2; j++)
        {
            int x2=spec[curr].first+i;
            int y2=spec[curr].second+j;

            if(in(x2,y2) and tab[x2][y2]!=0 and vis[tab[x2][y2]]==0) dfs(tab[x2][y2]);
        }
    }
}

void make_comps()
{
    for(int i=1; i<=k; i++)
    {
        if(!vis[i])
        {
            br_comp++;
            dfs(i);
        }
    }
}

long long curr_ans=-INF;

void rec(int comp, int i, long long ans)
{
    time_passed();

    if(i==sz[comp])
    {
        curr_ans=max(curr_ans,ans);
        return ;
    }

    for(int tp=1; tp<=4; tp++)
    {
        if(can_move(c[comp][i],tp))
        {
            long long cost=get_val(c[comp][i],tp);
            rec(comp,i+1,ans+cost);
            remove_val(c[comp][i],tp);
        }
    }
}

void solve()
{
    make_comps();
    //cout<<br_comp<<"\n";

    if(k*4>(long long)n*m)
    {
        cout<<"No"<<"\n";
        return ;
    }

    long long ans=0;
    for(int comp=1; comp<=br_comp; comp++)
    {
        ///pochni ot 0
        curr_ans=-INF;
        rec(comp,0,0);
        if(curr_ans<0)
        {
            cout<<"No"<<"\n";
            return ;
        }
        ans+=curr_ans;
    }

    cout<<ans<<"\n";
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    start = high_resolution_clock::now();

    read();
   // solve();

    cout<<"No"<<"\n";

    return 0;
}
/*
4 4
1 2 3 4
5 6 7 8
9 10 11 12
13 14 15 16
2
2 2
2 1
*/
