#include <bits/stdc++.h>
using namespace std;

long long x[1000001], y[1000001], rt[1000001], cells[1000001], min_cell[1000001], sum[1000001], sz[1000001];
long long n, m;

bool visited[1000001];

long long root(long long u) {
    if (rt[u] == u) return u;
    return rt[u] = root(rt[u]);
}

void connect(long long u, long long v, long long neg, long long neg_sum) {
    long long ru = root(u), rv = root(v);
    if (ru == rv) return;
    ///cout << "Connecting: (" << u << ", " << v << ")" << endl;

    cells[rv] += cells[ru] - neg;
    min_cell[rv] = min(min_cell[rv], min_cell[ru]);
    sum[rv] += sum[ru] - neg_sum;

    sz[rv] += sz[ru];

    rt[ru] = rv;
}

bool in_range(long long u, long long v) {
    return 1 <= u && u <= n && 1 <= v && v <= m;
}

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    cin >> n >> m;

    vector <vector <long long>> a(n + 10, vector <long long> (m + 10));
    vector <vector <long long>> special(n + 10, vector <long long> (m + 10));

    for (long long i = 1; i <= n; i++) {
        for (long long j = 1; j <= m; j++) {
            cin >> a[i][j];
        }
    }

    long long k;
    cin >> k;

    for (long long i = 1; i <= k; i++) {
        cin >> x[i] >> y[i];
        x[i]++;
        y[i]++;

        if (special[x[i][y[i]]) {
            cout << "No" << endl;
            return 0;
        }

        special[x[i]][y[i]] = i;

        rt[i] = i;

        long long current_cells = 1, mn = LLONG_MAX, s = a[x[i]][y[i]];

        if (x[i] != 1) {
            current_cells++;
            mn = min(mn, (long long) a[x[i] - 1][y[i]]);
            s += a[x[i] - 1][y[i]];
        }

        if (x[i] != n) {
            current_cells++;
            mn = min(mn, (long long) a[x[i] + 1][y[i]]);
            s += a[x[i] + 1][y[i]];
        }

        if (y[i] != 1) {
            current_cells++;
            mn = min(mn, (long long) a[x[i]][y[i] - 1]);
            s += a[x[i]][y[i] - 1];
        }

        if (y[i] != m) {
            current_cells++;
            mn = min(mn, (long long) a[x[i]][y[i] + 1]);
            s += a[x[i]][y[i] + 1];
        }

        cells[i] = current_cells;
        min_cell[i] = mn;
        sum[i] = s;
        sz[i] = 1;
        visited[i] = 0;
        /**cout << "Data of special cell #" << i << ":\n";
        cout << "\tCell: (" << x[i] << ", " << y[i] << ")\n";
        cout << "\tNumber or cells in pentamino: " << cells[i] << "\n";
        cout << "\tMinimum cell in pentamino (without center): " << min_cell[i] << "\n";
        cout << "\tSum of all cells in pentamino: " << sum[i] << "\n";
        cout << "\n";*/
    }

    for (long long i = 1; i <= k; i++) {
        if (in_range(x[i] - 2, y[i]) && special[x[i] - 2][y[i]]) connect(i, special[x[i] - 2][y[i]], 1, a[x[i] - 1][y[i]]);
        if (in_range(x[i] + 2, y[i]) && special[x[i] + 2][y[i]]) connect(i, special[x[i] + 2][y[i]], 1, a[x[i] + 1][y[i]]);
        if (in_range(x[i], y[i] - 2) && special[x[i]][y[i] - 2]) connect(i, special[x[i]][y[i] - 2], 1, a[x[i]][y[i] - 1]);
        if (in_range(x[i], y[i] + 2) && special[x[i]][y[i] + 2]) connect(i, special[x[i]][y[i] + 2], 1, a[x[i]][y[i] + 1]);

        if (special[x[i] - 1][y[i]]) connect(i, special[x[i] - 1][y[i]], 2, a[x[i]][y[i]] + a[x[i] - 1][y[i]]);
        if (special[x[i] + 1][y[i]]) connect(i, special[x[i] + 1][y[i]], 2, a[x[i]][y[i]] + a[x[i] + 1][y[i]]);
        if (special[x[i]][y[i] - 1]) connect(i, special[x[i]][y[i] - 1], 2, a[x[i]][y[i]] + a[x[i]][y[i] - 1]);
        if (special[x[i]][y[i] + 1]) connect(i, special[x[i]][y[i] + 1], 2, a[x[i]][y[i]] + a[x[i]][y[i] + 1]);

        if (special[x[i] - 1][y[i] - 1]) connect(i, special[x[i] - 1][y[i] - 1], 2, a[x[i] - 1][y[i]] + a[x[i]][y[i] - 1]);
        if (special[x[i] + 1][y[i] - 1]) connect(i, special[x[i] + 1][y[i] - 1], 2, a[x[i] + 1][y[i]] + a[x[i]][y[i] - 1]);
        if (special[x[i] - 1][y[i] + 1]) connect(i, special[x[i] - 1][y[i] + 1], 2, a[x[i] - 1][y[i]] + a[x[i]][y[i] + 1]);
        if (special[x[i] + 1][y[i] + 1]) connect(i, special[x[i] + 1][y[i] + 1], 2, a[x[i] + 1][y[i]] + a[x[i]][y[i] + 1]);
    }

    long long total_sum = 0;

    for (long long i = 1; i <= k; i++) {
        long long v = root(i);

        if (visited[v]) continue;
        visited[v] = 1;

        /**cout << "Component of special cell #" << v << ":\n";
        cout << "\tCell: (" << x[v] << ", " << y[v] << ")\n";
        cout << "\tNumber or cells in pentamino: " << cells[v] << "\n";
        cout << "\tMinimum cell in pentamino (without center): " << min_cell[v] << "\n";
        cout << "\tSum of all cells in pentamino: " << sum[v] << "\n";
        cout << "\tNumber of tetraminos needed to be placed: " << sz[v] << "\n";
        cout << "\n";*/

        if (sz[v] * 4 > cells[v]) {
            cout << "No" << endl;
            return 0;
        }

        if (sz[v] * 4 == cells[v]) {
            total_sum += sum[v];
        } else {
            total_sum += sum[v] - min_cell[v];
        }
    }

    cout << total_sum << endl;
    return 0;

}


