#include <bits/stdc++.h>
using namespace std;

long long x[1000001], y[1000001], rt[1000001], cells[1000001], min_cell[1000001], sum[1000001], sz[1000001];
long long n, m;

bool visited[1000001];

long long root(long long u) {
    if (rt[u] == u) return u;
    return rt[u] = root(rt[u]);
}

void connect(long long u, long long v, long long neg, long long neg_sum) {
    long long ru = root(u), rv = root(v);
    if (ru == rv) return;
    ///cout << "Connecting: (" << u << ", " << v << ")" << endl;

    cells[rv] += cells[ru] - neg;
    min_cell[rv] = min(min_cell[rv], min_cell[ru]);
    sum[rv] += sum[ru] - neg_sum;

    sz[rv] += sz[ru];

    rt[ru] = rv;
}

bool in_range(long long u, long long v) {
    return 1 <= u && u <= n && 1 <= v && v <= m;
}

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    cin >> n >> m;

    vector <vector <long long>> a(n + 10, vector <long long> (m + 10));
    vector <vector <long long>> special(n + 10, vector <long long> (m + 10));
    vector <vector <long long>> taken(n + 10, vector <long long> (m + 10));

    for (long long i = 1; i <= n; i++) {
        for (long long j = 1; j <= m; j++) {
            cin >> a[i][j];
        }
    }

    long long k;
    cin >> k;

    for (long long i = 1; i <= k; i++) {
        cin >> x[i] >> y[i];
        x[i]++;
        y[i]++;

        special[x[i]][y[i]] = i;
    }

    long long mx = -1;

    for (long long mask = 0; mask < (1LL << (2 * k)); mask++) {
        for (int i = 1; i <= k; i++) {
            taken[x[i]][y[i]] = 0;
            taken[x[i] - 1][y[i]] = 0;
            taken[x[i] + 1][y[i]] = 0;
            taken[x[i]][y[i] - 1] = 0;
            taken[x[i]][y[i] + 1] = 0;
        }

        for (int i = 1; i <= k; i++) {
            long long turn = (mask >> (2 * i - 2)) % 4;

            taken[x[i]][y[i]]++;
            if (turn != 0) taken[x[i] - 1][y[i]]++;
            if (turn != 1) taken[x[i] + 1][y[i]]++;
            if (turn != 2) taken[x[i]][y[i] - 1]++;
            if (turn != 3) taken[x[i]][y[i] + 1]++;
        }

        bool f = 1;

        for (int i = 1; i <= k; i++) {
            if (taken[x[i]][y[i]] > 1) {f = 0; break;}
            if (taken[x[i] - 1][y[i]] > 1) {f = 0; break;}
            if (taken[x[i] + 1][y[i]] > 1) {f = 0; break;}
            if (taken[x[i]][y[i] - 1] > 1) {f = 0; break;}
            if (taken[x[i]][y[i] + 1] > 1) {f = 0; break;}
        }

        if (f) {
            long long s = 0;

            for (int i = 1; i <= k; i++) {
                if (taken[x[i]][y[i]]) {
                    taken[x[i]][y[i]]--;
                    s += a[x[i]][y[i]];
                }
                if (taken[x[i] - 1][y[i]]) {
                    taken[x[i] - 1][y[i]]--;
                    s += a[x[i] - 1][y[i]];
                }
                if (taken[x[i] + 1][y[i]]) {
                    taken[x[i] + 1][y[i]]--;
                    s += a[x[i] + 1][y[i]];
                }
                if (taken[x[i]][y[i] - 1]) {
                    taken[x[i]][y[i] - 1]--;
                    s += a[x[i]][y[i] - 1];
                }
                if (taken[x[i]][y[i] + 1]) {
                    taken[x[i]][y[i] + 1]--;
                    s += a[x[i]][y[i] + 1];
                }
            }

            if (s > mx) {
                mx = s;
            }
        }
    }

    if (mx == -1) cout << "No" << endl;
    else cout << mx << endl;
    return 0;

}


