#include <iostream>
#include <bitset>
using namespace std;

#define D(x) cout << #x << ' ' << x << '\n'

int n, m, k;
int** a;
pair<int, int> coord[1000001];
int segIdx[1000001];
int maxSumSeg[1000001];
bitset<1000001> visitedDFS;
bool** taken;
int** cntr;

bool inbound(int i, int j) {
	return !(i < 0 || j < 0 || i >= n || j >= m);
}
///Missing equivalent to orientation
enum Missing : int8_t {
	UP = 0,
	LEFT = 1,
	RIGHT = 2,
	DOWN = 3,
	UNDEF = 5
};
void init() {
	cin >> n >> m;
	a = new int*[n]();
	cntr = new int*[n]();
	taken = new bool*[n]();
	for (int i = 0; i < n; i++) {
		a[i] = new int[m]();
		cntr[i] = new int[m]();
		taken[i] = new bool[m]();
		for (int j = 0; j < m; j++) {
			cin >> a[i][j];
			cntr[i][j] = -1;
			taken[i][j] = 0;
		}
	}
	cin >> k;
	for (int i = 0; i < k; i++) {
		cin >> coord[i].first >> coord[i].second;
		cntr[coord[i].first][coord[i].second] = i;
	}
}
void del() {
	for (int i = 0; i < n; i++) {
		delete[] a[i];
		delete[] cntr[i];
	}
	delete[] a;
	delete[] cntr;
}
void dfs(int segmentIdx, int idx) {
	if (visitedDFS[idx] == 1) {
		return;
	}
	visitedDFS[idx] = 1;
	///Primary function
	segIdx[idx] = segmentIdx;

	int y = coord[idx].first;
	int x = coord[idx].second;
	for (int i = y - 2; i <= y + 2; i++) {
		for (int j = x - 2; j <= x + 2; j++) {
			///If out of bounds || (i,j) == curPos || (i,j) isn't affected
			if (!inbound(i, j) || (i == y && j == x) || abs(i - y) + abs(j - x) > 2) {
				continue;
			}
			if (cntr[i][j] != -1) {
				dfs(segmentIdx, cntr[i][j]);
			}
		}
	}
}
void initSegIdx() {
	int idx = 0;
	for (int i = 0; i < k; i++) {
		if (!visitedDFS[i]) {
			dfs(idx, i);
			idx++;
		}
	}
}
///^ Works

pair<int, int> addDirTwice(int i, int j, Missing m) {
	if (m == UP) { i -= 2; }
	if (m == DOWN) { i += 2; }
	if (m == LEFT) { j -= 2; }
	if (m == RIGHT) { j += 2; }
	return { i, j };
}

inline bool canBePlaced(int i, int j, Missing m) {
	if (i == 0 && m != UP) { return 0; }
	if (i == n - 1 && m != DOWN) { return 0; }
	if (j == 0 && m != LEFT) { return 0; }
	if (j == m - 1 && m != RIGHT) { return 0; }

	if (taken[i - 1][j] && m != UP) { return 0; }
	if (taken[i + 1][j] && m != DOWN) { return 0; }
	if (taken[i][j - 1] && m != LEFT) { return 0; }
	if (taken[i][j + 1] && m != RIGHT) { return 0; }
	return 1;
}
inline int changeTaken(int i, int j, Missing m) {
	int ans = 0;
	taken[i][j] = !taken[i][j];
	ans += a[i][j];
	if (m != UP) {
		taken[i - 1][j] = !taken[i - 1][j];
		ans += a[i - 1][j];
	}
	if (m != DOWN) {
		taken[i + 1][j] = !taken[i + 1][j];
		ans += a[i + 1][j];
	}
	if (m != LEFT) {
		taken[i][j - 1] = !taken[i][j - 1];
		ans += a[i][j - 1];
	}
	if (m != RIGHT) {
		taken[i][j + 1] = !taken[i][j + 1];
		ans += a[i][j + 1];
	}
	return ans;
}

int chain(int st, Missing m = UNDEF) {
	int y = coord[st].first, x = coord[st].second;
	///Figure orientation out on your own, because only one exists
	if (m == UNDEF) {
		for (int i = Missing::UP; i <= Missing::DOWN; i++) {
			if (canBePlaced(y, x, Missing(i))) {
				m = Missing(i);
				break;
			}
		}
	}
	if (m == Missing::UNDEF || !canBePlaced(y, x, m)) {
		return -1;
	}
	int ans = changeTaken(y, x, m);

	for (int i = y - 2 + (m == UP); i <= y + 2 - (m == DOWN); i++) {
		for (int j = x - 2 + (m == LEFT); j <= x + 2 - (m == RIGHT); j++) {
			///If out of bounds || (i,j) == curPos || (i,j) isn't affected
			if (!inbound(i, j) || taken[i][j] || abs(i - y) + abs(j - x) > 2) {
				continue;
			}
			if (cntr[i][j] != -1) {
				int res = chain(cntr[i][j], UNDEF);
				if (res == -1) {
					changeTaken(y, x, m);
					return -1;
				}
				ans += res;
			}
		}
	}
	///Reset taken
	changeTaken(y, x, m);
	return ans;
}

void getMaxForSegment(int idx, int st) {
	int maxAns = -1;
	int y = coord[st].first, x = coord[st].second;
	for (int i = Missing::UP; i <= Missing::DOWN; i++) {
		int res = chain(st, Missing(i));
		int res2 = 0;
		pair<int, int> possCoords = addDirTwice(y, x, Missing(i));
		int tmpY = possCoords.first, tmpX = possCoords.second;
		if (inbound(tmpY, tmpX)) {
			if (cntr[tmpY][tmpX] != -1) {
				res2 = chain(cntr[tmpY][tmpX], Missing(i));
			}
		}
//		for (int q = 0; q < n; q++) {
//			for (int p = 0; p < m; p++) {
//				cout << taken[q][p] << ' ';
//			}
//			cout << "\n";
//		}
//		cout << "\n\n";
		if (res == -1 || res2 == -1) {
			continue;
		}
		maxAns = max(maxAns, res + res2);
	}
	maxSumSeg[idx] = maxAns;
}


int main () {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	init();
	initSegIdx();
//	for (int i = 0; i < n; i++) {
//		for (int j = 0; j < m; j++) {
//			if (cntr[i][j] == - 1) {
//				cout << "-1 ";
//			} else {
//				cout << segIdx[cntr[i][j]] << ' ';
//			}
//		}
//		cout << '\n';
//	}
	int ans = 0;
	for (int i = 0; i < k; i++) {
		if (maxSumSeg[segIdx[i]] == 0) {
			getMaxForSegment(segIdx[i], i);
			if (maxSumSeg[segIdx[i]] == -1) {
				ans = -1;
				break;
			}
			ans += maxSumSeg[segIdx[i]];
		}
	}
	if (ans == -1) {
		cout << "No";
		return 0;
	}
	cout << ans;
	del();
	return 0;
}
