#include <iostream>
#include <algorithm>
#include <bitset>
using namespace std;

#define D(x) cout << #x << ' ' << x << '\n'

int n, m, k;
int** a;
pair<int, int> coord[1000001];
int segIdx[1000001];
int segCycle[1000001];
int segClusered[1000001];
int segSum[1000001];
int segSmEl[1000001];
int maxSumSeg[1000001];
bitset<1000001> visitedDFS;
bool** taken;
int** cntr;
/**
7 5
1 2 1 1 1
1 1 1 1 1
1 1 3 1 1
1 1 2 1 1
1 1 1 1 1
1 3 2 3 1
1 1 3 1 1
4
0 1
2 2
5 2
2 4
*/

inline bool inbound(int i, int j) {
	return !(i < 0 || j < 0 || i >= n || j >= m);
}
int getSmNeighbour(int y, int x) {
	int ans = 2000000000;
	if (inbound(y - 1, x)) { ans = min(ans, a[y - 1][x]); }
	if (inbound(y + 1, x)) { ans = min(ans, a[y + 1][x]); }
	if (inbound(y, x - 1)) { ans = min(ans, a[y][x - 1]); }
	if (inbound(y, x + 1)) { ans = min(ans, a[y][x + 1]); }
	return ans;
}
///Missing equivalent to orientation
enum Missing : int8_t {
	UP = 0,
	LEFT = 1,
	RIGHT = 2,
	DOWN = 3,
	UNDEF = 5
};
void init() {
	cin >> n >> m;
	a = new int*[n]();
	cntr = new int*[n]();
	taken = new bool*[n]();
	for (int i = 0; i < n; i++) {
		a[i] = new int[m]();
		cntr[i] = new int[m]();
		taken[i] = new bool[m]();
		for (int j = 0; j < m; j++) {
			cin >> a[i][j];
			cntr[i][j] = -1;
			taken[i][j] = 0;
		}
	}
	cin >> k;
	for (int i = 0; i < k; i++) {
		cin >> coord[i].first >> coord[i].second;
		cntr[coord[i].first][coord[i].second] = i;
	}
}
void del() {
	for (int i = 0; i < n; i++) {
		delete[] a[i];
		delete[] cntr[i];
	}
	delete[] a;
	delete[] cntr;
}
void dfs(int segmentIdx, int idx, int lastY, int lastX) {
	if (visitedDFS[idx] == 1) {
		if (segCycle[segmentIdx] == -1) {
			segCycle[segmentIdx] = idx;
		}
		return;
	}
	visitedDFS[idx] = 1;
	///Primary function
	segIdx[idx] = segmentIdx;

	int y = coord[idx].first;
	int x = coord[idx].second;
	segSmEl[segmentIdx] = min(segSmEl[segmentIdx], getSmNeighbour(y, x));
	if (x == 0 || x == m - 1 || y == 0 || y == n - 1) {
		segClusered[segmentIdx] = idx;
	}
	for (int i = y - 2; i <= y + 2; i++) {
		for (int j = x - 2; j <= x + 2; j++) {
			///If out of bounds || (i,j) == curPos || (i,j) isn't affected
			if (!inbound(i, j) || (i == y && j == x) || abs(i - y) + abs(j - x) > 2) {
				continue;
			}
			if (i == lastY && j == lastX) {
				continue;
			}
			if (cntr[i][j] != -1) {
				if (!(abs(i - y) == 2 || abs(j - x) == 2)) {
					segClusered[segmentIdx] = idx;
				}
				dfs(segmentIdx, cntr[i][j], y, x);
			}
		}
	}
}
void initSegIdx() {
	int idx = 0;
	for (int i = 0; i < k; i++) {
		if (!visitedDFS[i]) {
			segClusered[idx] = -1;
			segCycle[idx] = -1;
			segSmEl[idx] = 2000000000;
			segSum[idx] = 0;
			dfs(idx, i, -1, -1);
			idx++;
		}
	}
}
void initSegSums() {
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			if (cntr[i][j] != -1) { segSum[segIdx[cntr[i][j]]] += a[i][j]; continue; }
			if (inbound(i - 1, j) && cntr[i - 1][j] != -1) { segSum[segIdx[cntr[i - 1][j]]] += a[i][j]; continue; }
			if (inbound(i + 1, j) && cntr[i + 1][j] != -1) { segSum[segIdx[cntr[i + 1][j]]] += a[i][j]; continue; }
			if (inbound(i, j - 1) && cntr[i][j - 1] != -1) { segSum[segIdx[cntr[i][j - 1]]] += a[i][j]; continue; }
			if (inbound(i, j + 1) && cntr[i][j + 1] != -1) { segSum[segIdx[cntr[i][j + 1]]] += a[i][j]; continue; }
		}
	}
}

pair<int, int> important;
bool impTaken = 0;

pair<int, int> addDirTwice(int i, int j, Missing m) {
	if (m == UP) { i -= 2; }
	if (m == DOWN) { i += 2; }
	if (m == LEFT) { j -= 2; }
	if (m == RIGHT) { j += 2; }
	return { i, j };
}

inline bool canBePlaced(int i, int j, Missing m) {
	if (i == 0 && m != UP) { return 0; }
	if (i == n - 1 && m != DOWN) { return 0; }
	if (j == 0 && m != LEFT) { return 0; }
	if (j == m - 1 && m != RIGHT) { return 0; }

	if (m != UP && taken[i - 1][j]) { return 0; }
	if (m != DOWN && taken[i + 1][j]) { return 0; }
	if (m != LEFT && taken[i][j - 1]) { return 0; }
	if (m != RIGHT && taken[i][j + 1]) { return 0; }
	return 1;
}
inline int changeTaken(int i, int j, Missing m) {
	int ans = 0;
	taken[i][j] = !taken[i][j];
	ans += a[i][j];
	if (m != UP) {
		taken[i - 1][j] = !taken[i - 1][j];
		ans += a[i - 1][j];
	}
	if (m != DOWN) {
		taken[i + 1][j] = !taken[i + 1][j];
		ans += a[i + 1][j];
	}
	if (m != LEFT) {
		taken[i][j - 1] = !taken[i][j - 1];
		ans += a[i][j - 1];
	}
	if (m != RIGHT) {
		taken[i][j + 1] = !taken[i][j + 1];
		ans += a[i][j + 1];
	}
	if (taken[important.first][important.second]) {
		impTaken = 1;
	}
	return ans;
}

int chain(int st, Missing m = UNDEF) {
	int y = coord[st].first, x = coord[st].second;
	///Figure orientation out on your own, because only one exists
	if (m == UNDEF) {
		for (int i = Missing::UP; i <= Missing::DOWN; i++) {
			if (canBePlaced(y, x, Missing(i))) {
				m = Missing(i);
			}
		}
	}
	if (m == Missing::UNDEF || !canBePlaced(y, x, m)) {
		return -1;
	}
	int ans = changeTaken(y, x, m);

	for (int i = y - 2 + (m == UP); i <= y + 2 - (m == DOWN); i++) {
		for (int j = x - 2 + (m == LEFT); j <= x + 2 - (m == RIGHT); j++) {
			///If out of bounds || (i,j) == curPos || (i,j) isn't affected
			if (!inbound(i, j) || taken[i][j] || abs(i - y) + abs(j - x) > 2) {
				continue;
			}
			if (cntr[i][j] != -1) {
				int res = chain(cntr[i][j], UNDEF);
				if (res == -1) {
					changeTaken(y, x, m);
					return -1;
				}
				ans += res;
			}
		}
	}
	///Reset taken
	changeTaken(y, x, m);
	return ans;
}

void getMaxForSegment(int idx, int st) {
	int maxAns = -1;
	if (segClusered[idx] != -1) {
		for (int i = Missing::UP; i <= Missing::DOWN; i++) {
			maxAns = max(maxAns, chain(segClusered[idx], Missing(i)));
		}
		maxSumSeg[idx] = maxAns;
		return;
	}
	if (segCycle[idx] != -1) {
		for (int i = Missing::UP; i <= Missing::DOWN; i++) {
			maxAns = max(maxAns, chain(segCycle[idx], Missing(i)));
		}
		maxSumSeg[idx] = maxAns;
		return;
	}

	///No cluster and no cycle => line
	maxSumSeg[idx] = segSum[idx] - segSmEl[idx];
}

int main () {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	init();
	initSegIdx();
	initSegSums();

//	for (int i = 0; i < n; i++) {
//		for (int j = 0; j < m; j++) {
//			if (cntr[i][j] == -1) {
//				cout << "- ";
//			} else {
//				cout << segIdx[cntr[i][j]] << ' ';
//			}
//		}
//		cout << '\n';
//	}
//	for (int i = 0; i < k; i++) {
//		cout << segClusered[segIdx[i]] << ' ' << segCycle[segIdx[i]] << ' ' << segSmEl[segIdx[i]] << ' ' << segSum[segIdx[i]] << '\n';
//	}

	int ans = 0;
	for (int i = 0; i < k; i++) {
		if (maxSumSeg[segIdx[i]] == 0) {
			getMaxForSegment(segIdx[i], i);
			if (maxSumSeg[segIdx[i]] == -1) {
				ans = -1;
				break;
			}
			ans += maxSumSeg[segIdx[i]];
		}
	}
	if (ans == -1) {
		cout << "No";
		return 0;
	}
	cout << ans;
	del();
	return 0;
}
