#include <bits/stdc++.h>
#include "segment.h"
using namespace std;

const long long MAXVALUE = 2 * 1e9;
const int MAXSQRT = sqrt(MAXVALUE) + 1;
const int MAXN = 3 * 1e6 + 1;
bool IsPrime[MAXSQRT];
std :: vector<int> Primes;
std :: vector<int> Positions[MAXN];
std :: unordered_map<int, int> Decode;
std :: set<int> Divisors;
int Code;

void Sieve()
{
    IsPrime[0] = true;
    IsPrime[1] = true;

    for(int i = 1; i * i < MAXSQRT; i++)
    {
        if(IsPrime[i]) continue;

        for(int j = i * i; j < MAXSQRT; j += i)
        {
            IsPrime[j] = true;
        }
    }

    for(int i = 2; i < MAXSQRT; i++)
    {
        if(IsPrime[i]) continue;
        Primes.push_back(i);
    }
}

long long max_segment(std :: vector<int> A)
{
    Sieve();

    for(int i = 0; i < (int)A.size(); i++)
    {
        int Copy = A[i];

        for(int j = 0; j < Primes.size() && Primes[j] * Primes[j] <= Copy; j++)
        {
            if(A[i] % Primes[j] != 0)
            {
                continue;
            }

            if(Decode[Primes[j]] == 0)
            {
                Code++;
                Decode[Primes[j]] = Code;
            }

            Positions[Decode[Primes[j]]].push_back(i);
            Divisors.insert(Decode[Primes[j]]);

            while(Copy % Primes[j] == 0)
            {
                Copy /= Primes[j];
            }
        }

        if(Copy != 1)
        {
            if(Decode[Copy] == 0)
            {
                Code++;
                Decode[Copy] = Code;
            }

            Positions[Decode[Copy]].push_back(i);
            Divisors.insert(Decode[Copy]);
        }
    }

    long long Answer = 0;

    for(auto& Div : Divisors)
    {
        long long Previous = -1;
        long long Gcd = 0;
        long long Streak = 0;

        for(auto& i : Positions[Div])
        {
            if(Previous == -1 || i - Previous == 1)
            {
                Gcd = __gcd(Gcd, (long long)A[i]);
                Streak++;
            }
            else
            {
                Gcd = A[i];
                Streak = 1;
            }

            Previous = i;
            Answer = max(Answer, Streak * Gcd);
        }
    }

    return Answer;
}