#include <bits/stdc++.h>
#include "segment.h"
using namespace std;

const long long MAXVALUE = 2 * 1e9;
const int MAXSQRT = sqrt(MAXVALUE) + 1;
const int MAXN = 3 * 1e6 + 1;
bool IsPrime[MAXSQRT];
std :: vector<int> Primes;
std :: vector<int> Positions[5 * MAXN];
std :: unordered_map<int, int> Decode;
std :: unordered_set<int> Divisors;
int Code;

void Sieve()
{
    IsPrime[0] = true;
    IsPrime[1] = true;

    for(int i = 1; i * i < MAXSQRT; i++)
    {
        if(IsPrime[i]) continue;

        for(int j = i * i; j < MAXSQRT; j += i)
        {
            IsPrime[j] = true;
        }
    }

    for(int i = 2; i < MAXSQRT; i++)
    {
        if(IsPrime[i]) continue;
        Primes.push_back(i);
    }
}

long long max_segment(std :: vector<int> A)
{
    Sieve();

    for(int i = 0; i < (int)A.size(); i++)
    {
        int Copy = A[i];

        for(int j = 0; j < (int)Primes.size() && Primes[j] * Primes[j] <= Copy; j++)
        {
            if(Copy % Primes[j] != 0)
            {
                continue;
            }

            int Hybrid = 1;

            while(Copy % Primes[j] == 0)
            {
                Hybrid *= Primes[j];
                Copy /= Primes[j];

                if(Decode[Hybrid] == 0)
                {
                    Code++;
                    Decode[Hybrid] = Code;
                }

                Positions[Decode[Hybrid]].push_back(i);
                Divisors.insert(Decode[Hybrid]);
            }
        }

        if(Copy != 1)
        {
            if(Decode[Copy] == 0)
            {
                Code++;
                Decode[Copy] = Code;
            }

            Positions[Decode[Copy]].push_back(i);
            Divisors.insert(Decode[Copy]);
        }
    }

    long long Answer = (int)A.size();

    for(auto& Div : Divisors)
    {
        int Previous = -1;
        int Gcd = 0;
        int Streak = 0;

        for(auto& i : Positions[Div])
        {
            if(Previous == -1 || i - Previous == 1)
            {
                Gcd = __gcd(Gcd, A[i]);
                Streak++;
            }
            else
            {
                Gcd = A[i];
                Streak = 1;
            }

            Previous = i;
            Answer = max(Answer, (long long)(Streak) * (long long)Gcd);
        }
    }

    return Answer;
}