#include <bits/stdc++.h>

#define endl '\n'

using namespace std;

typedef long long ll;

int n, m, k;
vector < vector < int > > a;
vector < pair < int, int > > special;
vector < vector < bool > > used;

void read()
{
    cin >> n >> m;
    a.resize(n);
    used.resize(n);
    for(int i = 0; i < n; i++)
    {
        a[i].resize(m);
        used[i].resize(m);
        for(int j = 0; j < m; j++)
        {
            cin >> a[i][j];
        }
    }
    cin >> k;
    for(int i = 0; i < k; i++)
    {
        int x, y;
        cin >> x >> y;
        special.push_back({x, y});
    }
}

bool inside(pair < int, int > p)
{
    int x = p.first;
    int y = p.second;
    return (0 <= x && x < n) && (0 <= y && y < m) && !used[x][y];
}

pair < int, int > get_left(int x, int y)
{
    return {x, y - 1};
}

pair < int, int > get_right(int x, int y)
{
    return {x, y + 1};
}

pair < int, int > get_up(int x, int y)
{
    return {x - 1, y};
}

pair < int, int > get_down(int x, int y)
{
    return {x + 1, y};
}

int get_val(pair < int, int > p)
{
    return a[p.first][p.second];
}

bool check(int idx, int type)
{
    int x = special[idx].first;
    int y = special[idx].second;

    if(type == 0)
    {
        pair < int, int > up = get_left(x, y);
        pair < int, int > right = get_up(x, y);
        pair < int, int > left = get_right(x, y);

        return inside(left) && inside(up) && inside(right);
    }
    else if(type == 1)
    {
        pair < int, int > up = get_up(x, y);
        pair < int, int > right = get_right(x, y);
        pair < int, int > down = get_down(x, y);

        return inside(up) && inside(right) && inside(down);
    }
    else if(type == 2)
    {
        pair < int, int > right = get_right(x, y);
        pair < int, int > down = get_down(x, y);
        pair < int, int > left = get_left(x, y);

        return inside(right) && inside(down) && inside(left);
    }
    else if(type == 3)
    {
        pair < int, int > down = get_down(x, y);
        pair < int, int > left = get_left(x, y);
        pair < int, int > up = get_up(x, y);

        return inside(down) && inside(left) && inside(up);
    }
    else assert(false);

    return false;
}

/// 0 -> up
/// 1 -> right
/// 2 -> down
/// 3 -> left

int add(int idx, int type)
{
    int x = special[idx].first;
    int y = special[idx].second;

    pair < int, int > p = special[idx];

    if(type == 0)
    {
        pair < int, int > up = get_left(x, y);
        pair < int, int > right = get_up(x, y);
        pair < int, int > left = get_right(x, y);

        return get_val(p) + get_val(left) + get_val(up) + get_val(right);
    }
    else if(type == 1)
    {
        pair < int, int > up = get_up(x, y);
        pair < int, int > right = get_right(x, y);
        pair < int, int > down = get_down(x, y);

        return get_val(p) + get_val(up) + get_val(right) + get_val(down);
    }
    else if(type == 2)
    {
        pair < int, int > right = get_right(x, y);
        pair < int, int > down = get_down(x, y);
        pair < int, int > left = get_left(x, y);

        return get_val(p) + get_val(right) + get_val(down) + get_val(left);
    }
    else if(type == 3)
    {
        pair < int, int > down = get_down(x, y);
        pair < int, int > left = get_left(x, y);
        pair < int, int > up = get_up(x, y);

        return get_val(p) + get_val(down) + get_val(left) + get_val(up);
    }
    else assert(false);

    return -1;
}

void mark(pair < int, int > p)
{
    used[p.first][p.second] = true;
}

void unmark(pair < int, int > p)
{
    used[p.first][p.second] = false;
}

void mark(int idx, int type)
{
    pair < int, int > p = special[idx];
    int x = p.first;
    int y = p.second;

    if(type == 0)
    {
        pair < int, int > up = get_left(x, y);
        pair < int, int > right = get_up(x, y);
        pair < int, int > left = get_right(x, y);

        mark(p);
        mark(up);
        mark(right);
        mark(left);
    }
    else if(type == 1)
    {
        pair < int, int > up = get_up(x, y);
        pair < int, int > right = get_right(x, y);
        pair < int, int > down = get_down(x, y);

        mark(p);
        mark(up);
        mark(right);
        mark(down);
    }
    else if(type == 2)
    {
        pair < int, int > right = get_right(x, y);
        pair < int, int > down = get_down(x, y);
        pair < int, int > left = get_left(x, y);

        mark(p);
        mark(right);
        mark(down);
        mark(left);
    }
    else if(type == 3)
    {
        pair < int, int > down = get_down(x, y);
        pair < int, int > left = get_left(x, y);
        pair < int, int > up = get_up(x, y);

        mark(p);
        mark(down);
        mark(left);
        mark(up);
    }
    else assert(false);
}

void unmark(int idx, int type)
{
    pair < int, int > p = special[idx];
    int x = p.first;
    int y = p.second;

    if(type == 0)
    {
        pair < int, int > up = get_left(x, y);
        pair < int, int > right = get_up(x, y);
        pair < int, int > left = get_right(x, y);

        unmark(p);
        unmark(up);
        unmark(right);
        unmark(left);
    }
    else if(type == 1)
    {
        pair < int, int > up = get_up(x, y);
        pair < int, int > right = get_right(x, y);
        pair < int, int > down = get_down(x, y);

        unmark(p);
        unmark(up);
        unmark(right);
        unmark(down);
    }
    else if(type == 2)
    {
        pair < int, int > right = get_right(x, y);
        pair < int, int > down = get_down(x, y);
        pair < int, int > left = get_left(x, y);

        unmark(p);
        unmark(right);
        unmark(down);
        unmark(left);
    }
    else if(type == 3)
    {
        pair < int, int > down = get_down(x, y);
        pair < int, int > left = get_left(x, y);
        pair < int, int > up = get_up(x, y);

        unmark(p);
        unmark(down);
        unmark(left);
        unmark(up);
    }
    else assert(false);
}

void solve()
{
    int ans = -1;
    for(int mask = 0; mask < (1 << (2 * n)); mask++)
    {
        int sum = 0;
        bool lampa = true;
        for(int i = 0; i < k; i++)
        {
            int type = (mask >> i) & 3;

            if(check(i, type))
            {
                sum += add(i, type);
                mark(i, type);
            }
            else
            {
                lampa = false;
                break;
            }
        }

        if(lampa)
        {
            ans = max(ans, sum);
        }

        for(int i = 0; i < k; i++)
        {
            int type = (mask >> i) & 3;

            unmark(i, type);
        }
    }

    if(ans == -1)
    {
        cout << "No" << endl;
    }
    else
    {
        cout << ans << endl;
    }
}

int main()
{
    ios_base :: sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    read();
    solve();

    return 0;
}