#include <bits/stdc++.h>

#define endl '\n'

using namespace std;

typedef long long ll;

ll n, m, k;
vector < vector < ll > > a;
vector < pair < ll, ll > > special;
vector < vector < bool > > used;

void read()
{
    cin >> n >> m;
    a.resize(n);
    used.resize(n);
    for(ll i = 0; i < n; i++)
    {
        a[i].resize(m);
        used[i].resize(m);
        for(ll j = 0; j < m; j++)
        {
            cin >> a[i][j];
        }
    }
    cin >> k;
    for(ll i = 0; i < k; i++)
    {
        ll x, y;
        cin >> x >> y;
        special.push_back({x, y});
    }
}

bool inside(pair < ll, ll > p)
{
    ll x = p.first;
    ll y = p.second;
    return (0 <= x && x < n) && (0 <= y && y < m) && !used[x][y];
}

pair < ll, ll > get_left(ll x, ll y)
{
    return {x, y - 1};
}

pair < ll, ll > get_right(ll x, ll y)
{
    return {x, y + 1};
}

pair < ll, ll > get_up(ll x, ll y)
{
    return {x - 1, y};
}

pair < ll, ll > get_down(ll x, ll y)
{
    return {x + 1, y};
}

ll get_val(pair < ll, ll > p)
{
    return a[p.first][p.second];
}

bool check(ll idx, ll type)
{
    ll x = special[idx].first;
    ll y = special[idx].second;

    if(type == 0)
    {
        pair < ll, ll > up = get_left(x, y);
        pair < ll, ll > right = get_up(x, y);
        pair < ll, ll > left = get_right(x, y);

        return inside(left) && inside(up) && inside(right);
    }
    else if(type == 1)
    {
        pair < ll, ll > up = get_up(x, y);
        pair < ll, ll > right = get_right(x, y);
        pair < ll, ll > down = get_down(x, y);

        return inside(up) && inside(right) && inside(down);
    }
    else if(type == 2)
    {
        pair < ll, ll > right = get_right(x, y);
        pair < ll, ll > down = get_down(x, y);
        pair < ll, ll > left = get_left(x, y);

        return inside(right) && inside(down) && inside(left);
    }
    else if(type == 3)
    {
        pair < ll, ll > down = get_down(x, y);
        pair < ll, ll > left = get_left(x, y);
        pair < ll, ll > up = get_up(x, y);

        return inside(down) && inside(left) && inside(up);
    }
    else assert(false);
}

/// 0 -> up
/// 1 -> right
/// 2 -> down
/// 3 -> left

ll add(ll idx, ll type)
{
    ll x = special[idx].first;
    ll y = special[idx].second;

    pair < ll, ll > p = special[idx];

    if(type == 0)
    {
        pair < ll, ll > up = get_left(x, y);
        pair < ll, ll > right = get_up(x, y);
        pair < ll, ll > left = get_right(x, y);

        return get_val(p) + get_val(left) + get_val(up) + get_val(right);
    }
    else if(type == 1)
    {
        pair < ll, ll > up = get_up(x, y);
        pair < ll, ll > right = get_right(x, y);
        pair < ll, ll > down = get_down(x, y);

        return get_val(p) + get_val(up) + get_val(right) + get_val(down);
    }
    else if(type == 2)
    {
        pair < ll, ll > right = get_right(x, y);
        pair < ll, ll > down = get_down(x, y);
        pair < ll, ll > left = get_left(x, y);

        return get_val(p) + get_val(right) + get_val(down) + get_val(left);
    }
    else if(type == 3)
    {
        pair < ll, ll > down = get_down(x, y);
        pair < ll, ll > left = get_left(x, y);
        pair < ll, ll > up = get_up(x, y);

        return get_val(p) + get_val(down) + get_val(left) + get_val(up);
    }
    else assert(false);

    return 0;
}

void mark(pair < ll, ll > p)
{
    used[p.first][p.second] = true;
}

void unmark(pair < ll, ll > p)
{
    used[p.first][p.second] = false;
}

void mark(ll idx, ll type)
{
    pair < ll, ll > p = special[idx];
    ll x = p.first;
    ll y = p.second;

    if(type == 0)
    {
        pair < ll, ll > up = get_left(x, y);
        pair < ll, ll > right = get_up(x, y);
        pair < ll, ll > left = get_right(x, y);

        mark(p);
        mark(up);
        mark(right);
        mark(left);
    }
    else if(type == 1)
    {
        pair < ll, ll > up = get_up(x, y);
        pair < ll, ll > right = get_right(x, y);
        pair < ll, ll > down = get_down(x, y);

        mark(p);
        mark(up);
        mark(right);
        mark(down);
    }
    else if(type == 2)
    {
        pair < ll, ll > right = get_right(x, y);
        pair < ll, ll > down = get_down(x, y);
        pair < ll, ll > left = get_left(x, y);

        mark(p);
        mark(right);
        mark(down);
        mark(left);
    }
    else if(type == 3)
    {
        pair < ll, ll > down = get_down(x, y);
        pair < ll, ll > left = get_left(x, y);
        pair < ll, ll > up = get_up(x, y);

        mark(p);
        mark(down);
        mark(left);
        mark(up);
    }
    else assert(false);
}

void unmark(ll idx, ll type)
{
    pair < ll, ll > p = special[idx];
    ll x = p.first;
    ll y = p.second;

    if(type == 0)
    {
        pair < ll, ll > up = get_left(x, y);
        pair < ll, ll > right = get_up(x, y);
        pair < ll, ll > left = get_right(x, y);

        unmark(p);
        unmark(up);
        unmark(right);
        unmark(left);
    }
    else if(type == 1)
    {
        pair < ll, ll > up = get_up(x, y);
        pair < ll, ll > right = get_right(x, y);
        pair < ll, ll > down = get_down(x, y);

        unmark(p);
        unmark(up);
        unmark(right);
        unmark(down);
    }
    else if(type == 2)
    {
        pair < ll, ll > right = get_right(x, y);
        pair < ll, ll > down = get_down(x, y);
        pair < ll, ll > left = get_left(x, y);

        unmark(p);
        unmark(right);
        unmark(down);
        unmark(left);
    }
    else if(type == 3)
    {
        pair < ll, ll > down = get_down(x, y);
        pair < ll, ll > left = get_left(x, y);
        pair < ll, ll > up = get_up(x, y);

        unmark(p);
        unmark(down);
        unmark(left);
        unmark(up);
    }
    else assert(false);
}

void solve()
{
    ll ans = 0;
    bool has = false;
    for(ll mask = 0; mask < (1 << (2 * k)); mask++)
    {
        ll sum = 0;
        bool lampa = true;
        for(ll i = 0; i < k; i++)
        {
            ll type = (mask >> i) & 3;

            if(check(i, type))
            {
                sum += add(i, type);
                mark(i, type);
            }
            else
            {
                lampa = false;
                break;
            }
        }

        if(lampa)
        {
            has = true;
            ans = max(ans, sum);
        }

        for(ll i = 0; i < k; i++)
        {
            ll type = (mask >> i) & 3;

            unmark(i, type);
        }
    }

    if(!has)
    {
        cout << "No" << endl;
    }
    else
    {
        cout << ans << endl;
    }
}

int main()
{
    ios_base :: sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    read();
    solve();

    return 0;
}