#include <bits/stdc++.h>

#define endl '\n'

using namespace std;

typedef long long ll;

const int MAXK = 1e6 + 10;

int n, m, k;
vector < vector < int > > a;
vector < vector < int > > used;
vector < pair < int, int > > special;

pair < int, int > dir[4] = {
    {0, 1},
    {1, 0},
    {-1, 0},
    {0, -1}
};

void read()
{
    cin >> n >> m;
    a.resize(n);
    used.resize(n);

    for(int i = 0; i < n; i++)
    {
        a[i].resize(m);
        used[i].resize(m);
        for(int j = 0; j < m; j++)
        {
            cin >> a[i][j];
            used[i][j] = -2;
        }
    }

    cin >> k;

    for(int i = 0; i < k; i++)
    {
        int x, y;
        cin >> x >> y;

        used[x][y] = -1;
        special.push_back({x, y});
    }
}

bool inside(int x, int y)
{
    return (0 <= x && x < n) && (0 <= y && y < m);
}

bool inside(pair < int, int > p)
{
    return inside(p.first, p.second);
}

int get_val(pair < int, int > p)
{
    return a[p.first][p.second];
}

pair < int, int > get_up(pair < int, int > p)
{
    return {p.first - 1, p.second};
}

pair < int, int > get_down(pair < int, int > p)
{
    return {p.first + 1, p.second};
}

pair < int, int > get_left(pair < int, int > p)
{
    return {p.first, p.second - 1};
}

pair < int, int > get_right(pair < int, int > p)
{
    return {p.first, p.second + 1};
}

int try_up(pair < int, int > p)
{
    int x = p.first;
    int y = p.second;

    pair < int, int > left = get_left(p);
    pair < int, int > up = get_up(p);
    pair < int, int > right = get_right(p);

    if(!inside(left) || !inside(up) || !inside(right))
    {
        return -1;
    }

    int ans = get_val(p) + get_val(left) + get_val(up) + get_val(right);

    return ans;
}

int try_right(pair < int, int > p)
{
    int x = p.first;
    int y = p.second;

    pair < int, int > up = get_up(p);
    pair < int, int > right = get_right(p);
    pair < int, int > down = get_down(p);

    if(!inside(down) || !inside(up) || !inside(right))
    {
        return -1;
    }

    int ans = get_val(p) + get_val(down) + get_val(up) + get_val(right);

    return ans;
}

int try_down(pair < int, int > p)
{
    int x = p.first;
    int y = p.second;

    pair < int, int > left = get_left(p);
    pair < int, int > right = get_right(p);
    pair < int, int > down = get_down(p);

    if(!inside(down) || !inside(left) || !inside(right))
    {
        return -1;
    }

    int ans = get_val(p) + get_val(down) + get_val(left) + get_val(right);

    return ans;
}

int try_left(pair < int, int > p)
{
    int x = p.first;
    int y = p.second;

    pair < int, int > left = get_left(p);
    pair < int, int > up = get_up(p);
    pair < int, int > down = get_down(p);

    if(!inside(down) || !inside(left) || !inside(up))
    {
        return -1;
    }

    int ans = get_val(p) + get_val(down) + get_val(left) + get_val(up);

    return ans;
}

int try_all(pair < int, int > p)
{
    return max({try_up(p), try_right(p), try_down(p), try_left(p)});
}

pair < int, int > to(pair < int, int > p1, pair < int, int > p2)
{
    if(p1.first == p2.first + 1)
    {
        return {2, 0};
    }
    else if(p1.first == p2.first - 1)
    {
        return {0, 2};
    }
    else if(p1.second == p2.second + 1)
    {
        return {1, 3};
    }
    else if(p1.second == p2.second - 1)
    {
        return {3, 1};
    }
}

void solve()
{
    int ans = 0;

    bool lampa = false;

    for(int i = 0; i < k; i++)
    {
        pair < int, int > p = special[i];

        if(used[p.first][p.second] != -1)
            continue;

        int cnt = 0;

        for(int l = 0; l < 4; l++)
        {
            pair < int, int > nb = {p.first + dir[l].first, p.second + dir[l].second};

            if(used[nb.first][nb.second] == -2) 
                continue;

            if(used[nb.first][nb.second] == -1)
            {
                cnt++;
                pair <int, int > pos = to(p, nb);

                used[p.first][p.second] = pos.first;
                used[nb.first][nb.second] = pos.second;

                if(pos.first == 0)
                    ans += try_up(p);
                else if(pos.first == 1)
                    ans += try_right(p);
                else if(pos.first == 2)
                    ans += try_down(p);
                else if(pos.first == 3)
                    ans += try_left(p);

                if(pos.second == 0)
                    ans += try_up(nb);
                else if(pos.second == 1)
                    ans += try_right(nb);
                else if(pos.second == 2)
                    ans += try_down(nb);
                else if(pos.second == 3)
                    ans += try_left(nb);
            }
            else
            {
                cnt++;
            }
        }
        
        if(cnt > 1)
        {
            lampa = true;
            break;
        }

        if(used[p.first][p.second] == -1)
        {
            ans += try_all(p);
        }
    }

    if(lampa)
    {
        cout << "No" << endl;
    }
    else
    {
        cout << ans << endl;
    }
}

int main()
{
    ios_base :: sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    read();
    ///solve();

    cout << "No" << endl;

    return 0;
}